using Autofac;
using FitConnect;
using Microsoft.Extensions.Logging;
using MockContainer;
using NUnit.Framework;

namespace FluentApiTest;

public class FluentSubscriberReceiveTests {
    private Client _client = null!;
    private IContainer _container = null!;
    private readonly string clientId = "clientId";
    private readonly string clientSecret = "clientSecret";
    private ILogger _logger = null!;
    private MockSettings _mockSettings = null!;

    [OneTimeSetUp]
    public void OneTimeSetup() {
        _container = Container.Create();
        _logger = _container.Resolve<ILogger>();
        _mockSettings = _container.Resolve<MockSettings>();
    }

    [SetUp]
    public void SetUp() {
        _client = new Client(
            FitConnectEndpoints.Create(FitConnectEndpoints.EndpointType.Development), clientId,
            clientSecret, container: _container, logger: _logger);
    }

    [Test]
    public void GetSubmission() {
        var submissions = _client.GetSubscriber("", "")
            .GetAvailableSubmissions();

        _client.GetSubscriber(_mockSettings.PrivateKeyDecryption, _mockSettings.PrivateKeySigning)
            .RequestSubmission("submissionId")
            .GetAttachments(attachments => {
                // Check if the attachments are valid
                return true;
            });
    }
}
